/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Entity;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI.Dialog;

namespace IPluginWikiDisplay_Example
{
    /* Class Declaration: Inherit from Plugin, implement IPluginWikiDisplay */
    public class IPluginWikiDisplay_Example : Plugin, IPluginWikiDisplay
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginWikiDisplay_Example(CPluginApi api)
            : base(api)
        {
        }

        #region IPluginWikiDisplay Members

        public CDialogItem[] WikiDisplayEdit(CWiki wiki)
        {
            /* display a dialog item for the Wiki configuration page with content,
             * label and instructions html provided */
            return new CDialogItem[] { new CDialogItem(
                @"<input type=""checkbox"" name=""unused"" /> 
                Created by WikiDisplayEdit method.", "Plugin Example",
                "Instructions are shown here.") };
        }

        public string[] WikiDisplayListFields(CWiki wiki)
        {
            /* Display a field containing the ixWiki value for the CWiki object */
            return new string[] { HttpUtility.HtmlEncode(wiki.ixWiki.ToString()) };
        }

        public string[] WikiDisplayListHeaders()
        {
            /* Display a label for our new field */
            return new string[] { "ixWiki" };
        }

        #endregion
    }
}